src/articles/urls.py
from django.urls import path
from . import views
from .views import PostListView, PostDetailView, PostCreateView, PostUpdateView, PostDeleteView, UserPostListView

app_name = 'articles'   #use in href 'app_name:path_name' in template
urlpatterns = [
	#path('', views.home, name='article-home'),
	path('', PostListView.as_view(), name='article-home'),
	path('post/<int:pk>/', PostDetailView.as_view(), name='post-detail'),
	path('post/new/', PostCreateView.as_view(), name='post-create'),
	path('post/<int:pk>/update/', PostUpdateView.as_view(), name='post-update'),
	path('post/<int:pk>/delete/', PostDeleteView.as_view(), name='post-delete'),
	path('about/', views.about, name='article-about'),
	path('user/<str:username>/', UserPostListView.as_view(), name='user-posts'),
]

src/myportal/urls.py
from django.contrib import admin
from django.urls import path, include
from accounts import views as account_views
from django.contrib.auth import views as auth_views

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('article/', include('articles.urls'), ),
    path('register/', account_views.register, name='register'),
    path('login/', auth_views.LoginView.as_view(template_name='account/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name='account/logout.html'), name='logout'),
    path('profile/', account_views.profile, name='profile'),
    path('password-reset/', auth_views.PasswordResetView.as_view(template_name='account/password_reset.html'), name='password-reset'),
    path('password-reset/done/', auth_views.PasswordResetDoneView.as_view(template_name='account/password_reset_done.html'), name='password-reset-done'),
    #default path name
    path('password-reset-confirm/<uidb64>/<token>/', auth_views.PasswordResetConfirmView.as_view(template_name='account/password_reset_confirm.html'), name='password_reset_confirm'),
    path('password-reset-complete/', auth_views.PasswordResetCompleteView.as_view(template_name='account/password_reset_complete.html'), name='password_reset_complete'),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

if settings.DEBUG:
	urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/articles/models.py
from django.db import models
from django.utils import timezone
from django.contrib.auth.models import User
from django.urls import reverse

# Create your models here.
# The following post model will be a class that inherits from django models.Model
class Post(models.Model):
	title = models.CharField(max_length=100)	 #attribute has some arguments
	content = models.TextField()
	date_posted = models.DateTimeField(default=timezone.now)
	author = models.ForeignKey(User, on_delete=models.CASCADE)

	def __str__(self):
		return self.title

	def snippet(self):	#custom method
		return '%s ...' % (self.content[:50])   #return self.content[:50] + '...'

		#(redirect)actually redirect to a specific route
		#(reverse)return full URL to that route as string
	def get_absolute_url(self):
		return reverse('post-detail', kwargs={'pk': self.pk})

src/articles/views.py
from django.shortcuts import render, get_object_or_404
from .models import Post 	#import Post class from models file
#from django.http import HttpResponse
from django.views.generic import ListView, DetailView, CreateView, UpdateView, DeleteView
from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin
from django.contrib.auth.models import User
# posts = [	#dummy information
# 	{
# 		'author': 'Fuad',
# 		'title': 'Post 1',
# 		'content': 'Content 1',
# 		'date_posted': 'September, 2019'
# 	},
# 	{
# 		'author': 'Fahim',
# 		'title': 'Post 2',
# 		'content': 'Content 2',
# 		'date_posted': 'October, 2019'
# 	},
# ]

# Create your views here.
def home(request):	#home funtion
	context = {
		'posts': Post.objects.all(),
	}
	return render(request, 'article/home.html', context)	  #three arguments- request object, template, context

class PostListView(ListView):   #home list view #class plv inherits from lv
	model = Post
	# <app>/<model>_<viewtype>.html -> article/post_list.html
	template_name = 'article/home.html'
	context_object_name = 'posts'
	ordering = ['-date_posted']
	paginate_by = 5

class UserPostListView(ListView):   #home list view #class plv inherits from lv
	model = Post
	template_name = 'article/user_posts.html'
	context_object_name = 'posts'
	paginate_by = 5

	def get_queryset(self):
		user = get_object_or_404(User, username=self.kwargs.get('username'))	#if user exists, go to blogs when not exist then return 404
		return Post.objects.filter(author=user).order_by('-date_posted')	#override filter method

class PostDetailView(DetailView):
	model = Post
	template_name = 'article/post_detail.html'

class PostCreateView(LoginRequiredMixin, CreateView):
	model = Post
	fields = ['title', 'content']
	template_name = 'article/post_form.html'

	#override form valid method
	def form_valid(self, form):
		form.instance.author = self.request.user   #take instance set author equals to current logged in user
		return super().form_valid(form)

class PostUpdateView(LoginRequiredMixin, UserPassesTestMixin, UpdateView):
	model = Post
	fields = ['title', 'content']
	template_name = 'article/post_form.html'

	#override form valid method
	def form_valid(self, form):
		form.instance.author = self.request.user
		return super().form_valid(form)

	def test_func(self):	#use for UserPassesTestMixin to add condition
		post = self.get_object()
		if self.request.user == post.author:
			return True
		return False

class PostDeleteView(LoginRequiredMixin, UserPassesTestMixin, DeleteView):
	model = Post
	template_name = 'article/post_delete.html'
	success_url = '/article/'

	def test_func(self):	#use for UserPassesTestMixin to add condition
		post = self.get_object()
		if self.request.user == post.author:
			return True
		return False

def about(request):
	return render(request, 'article/about.html', {'title': 'About'})   #change the title name by context

src/templates/article/about.html
{% extends "base_layout.html" %}

{% block content %}
	<h1>About Page</h1>
{% endblock content %}

src/templates/article/home.html
{% extends "base_layout.html" %}
	
{% block content %}
	
	{% for data in posts %}		<!-- key of dictionary is accessable in the template -->
		<article class="media content-section">
			<img class="rounded-circle article-img" src="{{ data.author.profile.image.url }}">
			<div class="media-body">
				<div class="article-metadata">
					<a class="mr-2" href="{% url 'articles:user-posts' data.author.username %}">{{ data.author }}</a>
					<small class="text-muted">{{ data.date_posted|date:"F d, Y" }}</small>
				</div>
				<h2><a class="article-title" href="{% url 'articles:post-detail' data.id %}">{{ data.title }}</a></h2>
				<p class="article-content">{{ data.snippet }}</p>
			</div>
		</article>
	{% endfor %}
	
	{% if is_paginated %}
		{% if page_obj.has_previous %}
			<a class="btn btn-outline-info mb-4" href="?page=1">First</a>
			<a class="btn btn-outline-info mb-4" href="?page={{ page_obj.previous_page_number }}">Previous</a>
		{% endif %}
	
		{% for num in page_obj.paginator.page_range %}
			{% if page_obj.number == num %}
				<a class="btn btn-info mb-4" href="?page={{ num }}">{{ num }}</a>
			{% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
				<a class="btn btn-outline-info mb-4" href="?page={{ num }}">{{ num }}</a>
			{% endif %}
		{% endfor %}

		{% if page_obj.has_next %}
			<a class="btn btn-outline-info mb-4" href="?page={{ page_obj.next_page_number }}">Next</a>
			<a class="btn btn-outline-info mb-4" href="?page={{ page_obj.paginator.num_pages }}">Last</a>
		{% endif %}
	{% endif %}

{% endblock content %}

src/templates/article/post_delete.html
{% extends "base_layout.html" %}

{% block content %}
	<div class="content-section">
		<form method="POST">
			{% csrf_token %}
			<fieldset class="form-group">
				<legend class="border-bottom mb-4">Delete Post</legend>
				<h2>Are you sure you want to delete the post "{{ object.title }}"</h2>
			</fieldset>
			<div class="form-group">
				<button class="btn btn-outline-danger" type="submit">Yes, Delete</button>
				<a class="btn btn-outline-secondary" href="{% url 'articles:post-detail' object.id %}">Cancel and go back to post</a>
			</div>
		</form>
	</div>
{% endblock content %}

src/templates/article/post_detail.html
{% extends "base_layout.html" %}
	
{% block content %}
	<article class="media content-section">
		<img class="rounded-circle article-img" src="{{ object.author.profile.image.url }}">
		<div class="media-body">
			<div class="article-metadata">
				<a class="mr-2" href="{% url 'profile' %}">{{ object.author }}</a>
				<small class="text-muted">{{ object.date_posted|date:"F d, Y" }}</small>
				{% if object.author == user %}
					<div>
						<a class="btn btn-secondary btn-sm mt-1 mb-1" href="{% url 'articles:post-update' object.id %}">Update</a>
						<a class="btn btn-danger btn-sm mt-1 mb-1" href="{% url 'articles:post-delete' object.id %}">Delete</a>
					</div>
				{% endif %}
			</div>
			<h2 class="article-title">{{ object.title }}</h2>
			<p class="article-content">{{ object.content }}</p>
		</div>
	</article>
{% endblock content %}

src/templates/article/post_form.html
{% extends "base_layout.html" %}
{% load crispy_forms_tags %}

{% block content %}
	<div class="content-section">
		<form method="POST">
			{% csrf_token %}
			<fieldset class="form-group">
				<legend class="border-bottom mb-4">Blog Post</legend>
				<!-- {{ form.as_p }} use for show the form field as paragraph -->
				{{ form|crispy }}
			</fieldset>
			<div class="form-group">
				<button class="btn btn-outline-info" type="submit">Post</button>
			</div>
		</form>
	</div>
{% endblock content %}

src/templates/article/user_posts.html
{% extends "base_layout.html" %}
	
{% block content %}

	<h1 class="mb-3">Posts by {{ view.kwargs.username }} ({{ page_obj.paginator.count }})</h1>
	
	{% for data in posts %}		<!-- key of dictionary is accessable in the template -->
		<article class="media content-section">
			<img class="rounded-circle article-img" src="{{ data.author.profile.image.url }}">
			<div class="media-body">
				<div class="article-metadata">
					<a class="mr-2" href="{% url 'articles:user-posts' data.author.username %}">{{ data.author }}</a>
					<small class="text-muted">{{ data.date_posted|date:"F d, Y" }}</small>
				</div>
				<h2><a class="article-title" href="{% url 'articles:post-detail' data.id %}">{{ data.title }}</a></h2>
				<p class="article-content">{{ data.content }}</p>
			</div>
		</article>
	{% endfor %}
	
	{% if is_paginated %}
		{% if page_obj.has_previous %}
			<a class="btn btn-outline-info mb-4" href="?page=1">First</a>
			<a class="btn btn-outline-info mb-4" href="?page={{ page_obj.previous_page_number }}">Previous</a>
		{% endif %}
	
		{% for num in page_obj.paginator.page_range %}
			{% if page_obj.number == num %}
				<a class="btn btn-info mb-4" href="?page={{ num }}">{{ num }}</a>
			{% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
				<a class="btn btn-outline-info mb-4" href="?page={{ num }}">{{ num }}</a>
			{% endif %}
		{% endfor %}

		{% if page_obj.has_next %}
			<a class="btn btn-outline-info mb-4" href="?page={{ page_obj.next_page_number }}">Next</a>
			<a class="btn btn-outline-info mb-4" href="?page={{ page_obj.paginator.num_pages }}">Last</a>
		{% endif %}
	{% endif %}

{% endblock content %}